p = () => new Promise(resolve => setTimeout(resolve, 1000));

p().then(() => console.log('Example 1: promise fulfilled'));;

let foo = () => 'foo'; // data to be returned

let getFoo = () => new Promise(resolve => setTimeout(resolve(foo(), 1000)));

getFoo().then(onFulfilled => console.log('Example 2: ' + onFulfilled));;

const rq = require('request-json-light');

let client = rq.newClient('http://jsonplaceholder.typicode.com/');

let clientGet = (client, slug, prop) =>
    new Promise((resolve, reject) =>
        client.get(slug, (error, response, body) =>
            (response.statusCode === 200)
                ? resolve(body[prop])
                : reject(response.statusCode)));;

clientGet(client, 'users/1', 'username')
    .then(username => console.log('Example 3: ' + username))
    .catch(err => console.log(err));;

clientGet(client, 'foo', 'bar')
    .then(result => console.log(result))
    .catch(err => console.log('Example 4: ' + err));;

clientGet(client, 'users/1', 'username')
    .then(username => username + 'foo') // 'Bret' -> 'Bretfoo'
    .then(usernamefoo => console.log('Example 5: ' + usernamefoo))
    .catch(err => console.log(err));;

clientGet(client, 'users/1', 'username')
    .then(() => clientGet(client, 'users/2', 'username'))
    .then(username2 => console.log('Example 6: ' + username2))
    .catch(err => console.log(err));;

let p1 = clientGet(client, 'users/1', 'username'),
    p2 = clientGet(client, 'users/2', 'username');

Promise.all([p1, p2])
    .then(usernames => console.log('Example 7: ' + usernames)) // array [p1, p2]
    .catch(err => console.log(err));;

Promise.race([p1, p2])
    .then(username => console.log('Example 8: winner is ' + username))
    .catch(err => console.log(err));;